<template>
  <div class="workspace-area d-flex flex-grow-1 flex-column">
    <div class="main-workspace-area position-relative d-flex flex-grow-1">
      <layer-vertical-panel name="layer-panel"></layer-vertical-panel>
      <leaflet-map></leaflet-map>
    </div>
    <tool-bar></tool-bar>
  </div>
</template>

<script>
import MomentMixin from '@/core/mixins/moment'
import { REMOVE_WORKSPACE } from '@/store'
import ToolBar from '@/dashboard/components/ToolBar'
import LeafletMap from '@/dashboard/components/map/LeafletMap'
import LayerVerticalPanel from '@/dashboard/components/layers/LayerVerticalPanel'


export default {
  name: 'workspacearea',

  // List with all the mixins that are used by the WorkspaceArea component.
  mixins: [
    MomentMixin,
  ],

  // Props used by the WorkspaceArea component.
  props: {
    identifier: {
      type: String,
      required: true,
    }
  },

  // Computed properties for the WorkspaceArea component.
  computed: {
    step: {
      get() {
        return this.$store.state.workspaces[this.identifier].step
      },
    },

    referenceTime: {
      get() {
        return this.$store.state.workspaces[this.identifier].referenceTime
      },
    },

    workspace: {
      get() {
        return this.identifier
      }
    },
  },

  destroyed() {
    // When the workspace area is destroyed, we also remove the store module owned by
    // this component from the global store.
    this.$store.commit(REMOVE_WORKSPACE, { workspaceId: this.identifier })
  },

  components: {
    ToolBar,
    LeafletMap,
    LayerVerticalPanel,
  },
}
</script>
